package org.bdware.server.nodecenter;

import org.apache.logging.log4j.LogManager;
import org.apache.logging.log4j.Logger;
import org.bdware.sc.units.RequestCache;
import org.bdware.server.NodeCenterServer;

import java.util.Map;
import java.util.concurrent.ConcurrentHashMap;
import java.util.concurrent.TimeUnit;

public class MasterActions {
    private static final Logger LOGGER = LogManager.getLogger(MasterActions.class);
    // TODO  定期清缓存
    public static Map<String, RequestCache> requestCache =
            new ConcurrentHashMap<>(); // key is contractID,only for requestAll type contract

    static {
        NodeCenterServer.scheduledThreadPool.scheduleWithFixedDelay(
                () -> {
                    boolean flag = clearCache();
                    if (flag) {
                        try {
                            Thread.sleep(10000L);
                        } catch (InterruptedException e) {
                            LOGGER.error("sleeping is interrupted! " + e.getMessage());
                        }
                    }
                },
                0,
                0,
                TimeUnit.SECONDS);
    }

    public NodeCenterFrameHandler controller;

    public MasterActions(NodeCenterFrameHandler nodeCenterFrameHandler) {
        controller = nodeCenterFrameHandler;
    }

    // judge the just online node whwther need to restart contracts,send the contracts'info
    /*    public static void restartContracts(String nodePubKey){
        if(!NodeCenterActions.recoverMap.containsKey(nodePubKey)){
            return;
        }

        System.out.println("开始恢复节点" + NodeCenterActions.nodeinfos.get(nodePubKey).nodeName);


        // 恢复该节点的每一个集群运行的合约
        for (ContractRecord record : NodeCenterActions.recoverMap.get(nodePubKey).values()) {
            String contractID = record.contractID;
            if (record.recoverFlag != RecoverFlag.ToRecover)
                continue;

            Map<String, String> req = new HashMap<String, String>();
            req.put("action", "queryUnitStatus");
            req.put("contractID", contractID);
            CMNode cmNode = NodeCenterActions.nodeinfos.get(nodePubKey);
            cmNode.connection.controller.sendMsg(gson.toJson(req));
        }
    }*/

    /*    @Action(async = true)
    public void onQueryUnitStatus(Map<String, String> args, final ResultCallback rc) {
        String mode = args.get("mode");
        String nodeID = args.get("nodeID");
        String contractID = args.get("contractID");
        ContractRecord record = NodeCenterActions.recoverMap.get(nodeID).get(contractID);
        logger.debug("节点" + NodeCenterActions.nodeinfos.get(args.get("nodeID")).nodeName + "崩溃前模式为" + mode);
        if(mode.equals(ContractUnitStatus.CommonMode.toString())){
            restartFromCommonMode(nodeID,record);
        }else if(mode.equals(ContractUnitStatus.StableMode.toString())){
            restartFromStableMode(nodeID,record);
        }
    }*/

    // 当StableMode的节点的lastExeSeq和集群相差超过10时，通过CommonNode的恢复方式恢复
    /*     @Action(async = true)
    public void restartByCommonNode(Map<String, String> args, final ResultCallback rc){
         String nodeID = args.get("nodeID");
         String contractID = args.get("contractID");
         ContractRecord record = NodeCenterActions.recoverMap.get(nodeID).get(contractID);
         restartFromCommonMode(nodeID,record);
     }*/

    /*
        public static void restartFromCommonMode(String nodePubKey,ContractRecord record){
            logger.debug("从CommonMode中恢复:");

            String contractID = record.contractID;

            record.recoverFlag = RecoverFlag.Recovering;
            //先发消息，让恢复节点的该合约收到消息后只加入队列不dealRequests
            Map<String, String> request = new HashMap<>();
            request.put("action", "setRecovering");
            request.put("contractID",contractID);
            CMNode node = NodeCenterActions.nodeinfos.get(nodePubKey);
            node.connection.controller.sendMsg(gson.toJson(request));

            //System.out.println("第一步 : [NodeCeterActions] restartContracts  开始处理合约  contractID=" + contractID);

            if (NodeCenterActions.contractID2Members.containsKey(contractID)) {

                // 在nodeinfos中找节点，该节点的pubKey在pubKeys中
                MultiPointContractInfo info = NodeCenterActions.contractID2Members.get(contractID);
                CMNode cmNode = null;
                for (int i = 0; i < info.members.size(); i++) {
                    int size = info.members.size();
                    String tempNodeID = info.members.get(record.order.incrementAndGet() % size);

                    if(NodeCenterActions.nodeinfos.containsKey(tempNodeID))
                        cmNode = NodeCenterActions.nodeinfos.get(tempNodeID);
                    else continue;

                    //System.out.println("查询节点  " + cmNode.nodeName);

                    if (cmNode != null && !cmNode.pubKey.equals(nodePubKey)) {
                        //System.out.println("第二步 : [NodeCenterActions] 找到一个依赖恢复节点，其节点名为 " + cmNode.nodeName);

                        Map<String, String> req = new HashMap<String, String>();
                        req.put("action", "dumpCurrentState");
                        req.put("contractID", contractID);
                        req.put("targetNodePubkey", nodePubKey);

                        // NC向该节点发送请求，让其存储自身当前状态并发给NC
                        cmNode.connection.controller.sendMsg(gson.toJson(req));

                        return;
                    }
                }

                if(cmNode == null){
                    logger.debug("[NodeCenterActions] Can't find a recover rely node!");
                }
            }
        }
    */

    // TODO
    /*    public static void restartFromStableMode(String nodePubkey,ContractRecord record){
        logger.debug("从StableMode中恢复:");

        String contractID = record.contractID;
        record.recoverFlag = RecoverFlag.Recovering;
        //先发消息，让恢复节点的该合约收到消息后只加入队列不dealRequests
        Map<String, String> request = new HashMap<>();
        request.put("action", "setRecovering");
        request.put("contractID",contractID);
        request.put("mode", ContractUnitStatus.StableMode.toString());
        int lastExeSeq = NodeCenterActions.contractID2Members.get(contractID).ai.get() - 1;
        request.put("lastExeSeq",lastExeSeq + "");
        CMNode node = NodeCenterActions.nodeinfos.get(nodePubkey);
        node.connection.controller.sendMsg(gson.toJson(request));
    }*/

    /*    public static void unitModeCheck(String contractID){
        MultiPointContractInfo mpci = NodeCenterActions.contractID2Members.get(contractID);
        int total = 0,online = 0;
        for(String nodeId : mpci.members){
            if(NodeCenterActions.nodeinfos.containsKey(nodeId)){
                online++;
            }
            total++;
        }

        logger.debug("合约" + contractID + "的集群,上线节点有" + online + "个,总共节点有" + total + "个.  Math.ceil(total / 2)=" + Math.ceil((double)total / 2)  + "  online > Math.ceil(total / 2)" + (online > Math.ceil(total / 2)) + "  mpci.unitStatus=" + mpci.unitStatus);
        if(online > Math.ceil((double)total / 2) && mpci.unitStatus == ContractUnitStatus.StableMode){
            logger.debug("合约" + contractID + "的集群更改模式为" + ContractUnitStatus.CommonMode.toString());

            Map<String, String> req = new HashMap<String, String>();
            req.put("action", "changeUnitStatus");
            req.put("contractID", contractID);
            req.put("mode",ContractUnitStatus.CommonMode.toString());
            for(String nodeId : mpci.members){
                if(NodeCenterActions.nodeinfos.containsKey(nodeId)){
                    CMNode cmNode = NodeCenterActions.nodeinfos.get(nodeId);
                    logger.debug("发消息给节点 " + cmNode.nodeName + " 设置合约" + contractID + "的集群模式为CommonMode");
                    cmNode.connection.controller.sendMsg(gson.toJson(req));
                }
            }

            mpci.unitStatus = ContractUnitStatus.CommonMode;
        }else if(online <= Math.ceil((double)total / 2) && mpci.unitStatus == ContractUnitStatus.CommonMode){
            logger.debug("合约" + contractID + "的集群更改模式为" + ContractUnitStatus.StableMode.toString());

            Map<String, String> req = new HashMap<String, String>();
            req.put("action", "changeUnitStatus");
            req.put("contractID", contractID);
            req.put("mode",ContractUnitStatus.StableMode.toString());
            for(String nodeId : mpci.members){
                if(NodeCenterActions.nodeinfos.containsKey(nodeId)){
                    CMNode cmNode = NodeCenterActions.nodeinfos.get(nodeId);
                    Map<String,String> map = NodeCenterActions.recoverMap.get(nodeId).get(contractID).members;
                    req.put("membersStr",JsonUtil.toJson(map)); //ContractRecord's members
                    logger.debug("发消息给节点 " + cmNode.nodeName + " 设置合约" + contractID + "的集群模式为StableMode");
                    cmNode.connection.controller.sendMsg(gson.toJson(req));
                }
            }

            mpci.unitStatus = ContractUnitStatus.StableMode;

            //将ContractRecord中members发给集群中节点

        }
    }*/

    /*    @Action(async = true)
    public void recoverFinish(Map<String, String> args, final ResultCallback rc) {
        ContractRecord cr = NodeCenterActions.recoverMap.get(args.get("nodeID")).get(args.get("contractID"));
        logger.debug("节点" + NodeCenterActions.nodeinfos.get(args.get("nodeID")).nodeName + "恢复完成!");
        if(cr.recoverFlag == RecoverFlag.Recovering)
            cr.recoverFlag = RecoverFlag.Fine;

        logger.debug("恢复完成，需要检查合约" + args.get("contractID") + "的集群运行模式");
        unitModeCheck(args.get("contractID"));
    }*/

    static boolean clearCache() {
        if (requestCache.isEmpty()) return true;

        //        final long time = System.currentTimeMillis() - 60000L;   //60s
        //        requestCache.entrySet()
        //                .removeIf(
        //                        entry -> {
        //                            RequestCache cache = entry.getValue();
        //                            if (cache == null) return true;
        //                            return cache.getTime() < time;
        //                        });
        //
        //        return false;

        // 对每个合约，只保存最近RESERVED个请求
        //        for(RequestCache rc : requestCache.values()){
        //            int delete = rc.size() - RequestCache.RESERVED,count = 0;
        //            if(delete > 0){
        //                synchronized (rc){
        //                    for(Iterator<Integer> iterator = rc.requests.keySet().iterator();
        // iterator.hasNext(); ) {
        //                        Integer key = iterator.next();
        //                        if(count < delete){
        //                            iterator.remove();
        //                            count++;
        //                        }
        //                    }
        //                }
        //            }
        //        }

        return false;
    }

    static RequestCache getCache(String contractID) {
        if (contractID != null) {
            RequestCache cache = requestCache.get(contractID);
            if (cache != null) return cache;
            else {
                LOGGER.debug("[NodeCenterActions] create requestcache:" + contractID);
                RequestCache reqc = new RequestCache();
                requestCache.put(contractID, reqc);
                return reqc;
            }
        }
        return null;
    }

    /*    @Action(async = true)
    public void sendCachedRequests(Map<String, String> args, final ResultCallback rc) {
        String contractID = args.get("contractID");
        int start = Integer.parseInt(args.get("start"));
        int end = Integer.parseInt(args.get("end"));

        RequestCache cache = getCache(contractID);
        for(int i = start + 1;i < end;i++){
            if(cache == null || !cache.containsKey(i)){
                //this node crash
                String nodeID = args.get("nodeID");
                MasterActions.restartContracts(nodeID);
            }
            JsonObject jo = cache.get(i);
            if(jo == null){
                logger.debug("在NC中第 " + i + "个请求已经被清,无法发给恢复节点!");
            }else
                controller.sendMsg(JsonUtil.toJson(jo));

            logger.debug("NC发送第 " + i + "    " + jo.get("seq").getAsString() + " 个请求给Node");
        }
    }*/
}
